var OnlyMySites = {

listeners : {

QueryInterface: function(aIID) {
  if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
    aIID.equals(Components.interfaces.nsIObserver) ||
    aIID.equals(Components.interfaces.nsISupports))
    return this;
  throw Components.results.NS_NOINTERFACE;
},


// Called when the URI of the document displayed in the tab changes.
onLocationChange: function(WebProgress, aRequest, URI) {
  if (URI == null)
    return;

  var url = gBrowser.selectedBrowser.contentDocument.location.href.toLowerCase();
  if (/^(?:about|file|chrome):/.test(url))
   return;

  var urlArray = url.split('/');
  url = urlArray[2];


//OnlyMySites.Log_write(url);

var vars = new RegExp('(?:'+OnlyMySites.Sites+')$');
OnlyMySites.Log_write(vars);
  if (!vars.test(url)) {
//        gBrowser.selectedBrowser.contentDocument.location.href='about:home';
    window.stop();
  }
}
},//listeners


uninstall4 : {
  onUninstalling: function(addon) {
    if ( (addon.id == 'OnlyMySitesAddon@gmail.com') && (!OnlyMySites.authenticate()) )
      AddonManager.getAddonByID('OnlyMySitesAddon@gmail.com', function(addon) { addon.cancelUninstall(); });
  },

  onDisabling: function(addon) {
    if ( (addon.id == 'OnlyMySitesAddon@gmail.com') && (!OnlyMySites.authenticate()) )
      AddonManager.getAddonByID('OnlyMySitesAddon@gmail.com', function(addon) { addon.userDisabled=false; });
  }
},//uninstall4


observer : {
  observe: function(aSubject, aTopic, aData) {
   if (aTopic == 'em-action-requested') {
      aSubject.QueryInterface(Components.interfaces.nsIUpdateItem);
      if (aSubject.id == 'OnlyMySitesAddon@gmail.com') {
        var ext = Components.classes['@mozilla.org/extensions/manager;1'].getService(Components.interfaces.nsIExtensionManager);
        if ( (aData == 'item-uninstalled') && (!OnlyMySites.authenticate()) )
          ext.cancelUninstallItem('OnlyMySitesAddon@gmail.com');
        if ( (aData == 'item-disabled') && (!OnlyMySites.authenticate()) )
          ext.enableItem('OnlyMySitesAddon@gmail.com');
      }
    }
  },

  observerService : Components.classes['@mozilla.org/observer-service;1'].getService(Components.interfaces.nsIObserverService),
  register: function() {
   this.observerService.addObserver(this, 'http-on-modify-request', false);
   try {
     Components.utils.import('resource://gre/modules/AddonManager.jsm');
     AddonManager.addAddonListener(OnlyMySites.uninstall4);
   } catch (ex) {
     this.observerService.addObserver(this, 'em-action-requested', false);
     this.observerService.addObserver(this, 'quit-application-granted', false);
   }
  },
  unregister: function() {
    this.observerService.removeObserver(this, 'http-on-modify-request');
    try {
      Components.utils.import('resource://gre/modules/AddonManager.jsm');
      AddonManager.removeAddonListener(OnlyMySites.uninstall4);
    } catch (ex) {
      this.observerService.removeObserver(this,'em-action-requested');
      this.observerService.removeObserver(this,'quit-application-granted');
    }
  }
},//observer


listenerHandler : {
  init: function() {
    OnlyMySites.observer.register();
    gBrowser.addProgressListener(OnlyMySites.listeners, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
  },

  uninit: function() {
    OnlyMySites.observer.unregister();
    gBrowser.removeProgressListener(OnlyMySites.listeners);
  }
},//listenerHandler







prefs : Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService)
        .getBranch('extensions.OnlyMySites.'),

Sites: '',

init_finish: false,

///////







/////////////////////////////////////////////////////////////////////////////


init: function() {

if (!this.init_finish) {
  // listener
  this.listenerHandler.init();

  // Initialization
  this.Load_prefs();

  this.init_finish = true;
}
},





unload: function() {
  this.listenerHandler.uninit();
},















// Load vars
Load_prefs: function() {
  this.Sites = this.prefs.getComplexValue('Sites', Components.interfaces.nsISupportsString).data;
},

// Save vars
Save_prefs: function() {
  var str = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
//  this.User_Rgxp_Block_TMBAhtml = this.User_Rgxp_Block_TMBAhtml.replace(/\ /g, '');
    var list = this.Sites.split(","),
        Sites = '';
    for (var i=0; i < list.length; i++) {
      if (list[i] != '') {
        list[i] = list[i].toLowerCase();
        list[i] = list[i].replace(/\ /g, '')
                  .replace(/^(?:ht|f)tps?:\/\//, '')
                  .replace(/^www\./, '')
                  .replace(/\//, '')
                  .replace(/\./g, '\\.')
                  .replace(/\\\\\./g, '\\.')
//                  .replace(/^\|/, '');
;
        Sites += list[i] + '|';
      }
    }
  if (/\|$/.test(Sites))
    Sites = Sites.substring(0, Sites.length-1);

    this.Sites = Sites;
  str.data = this.Sites;
  this.prefs.setComplexValue('Sites', Components.interfaces.nsISupportsString, str);

},


// User click 'update subscribe' or 'update Regexps' or change options
ReLoad_prefs: function() {
    this.Load_prefs();
    this.Save_prefs();
    this.init();
},







































ConsoleService : Components.classes['@mozilla.org/consoleservice;1']
                 .getService(Components.interfaces.nsIConsoleService),

Log_write: function(arg1) {
  this.ConsoleService.logStringMessage('OnlyMySites: ' + arg1);
},

Show_Warning: function(arg1) {
 try {
    Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService)
    .showAlertNotification('chrome://OnlyMySites/skin/icon.png', 'OnlyMySites', arg1);
  } catch (e) {
    alert('OnlyMySites: '+arg1); // fix for MacOS without Growl
  }
},












PrefService : Components.classes['@mozilla.org/preferences-service;1']
              .getService(Components.interfaces.nsIPrefService),

open_settings: function() {
  if (!this.authenticate())
    return false;
  // instantApply on windows = false, on linux = true, on mac = i don't no
  // i need instantApply = false
  // it is necessary to track user actions and allow the user to undo the changes.
  var instantApply = this.PrefService.getBoolPref('browser.preferences.instantApply');
  if (instantApply)
    this.PrefService.setBoolPref('browser.preferences.instantApply', false);
  window.openDialog('chrome://OnlyMySites/content/settings.xul','_blank','chrome,centerscreen,resizable=yes,modal').focus();
  if (instantApply)
    this.PrefService.setBoolPref('browser.preferences.instantApply', true);
  this.ReLoad_prefs();
},








authenticate: function() {
  var myLoginManager = Components.classes['@mozilla.org/login-manager;1'].getService(Components.interfaces.nsILoginManager);
  var logins = myLoginManager.findLogins({}, 'chrome://OnlyMySites', null, 'Pref. Pass');

  var pass = false;
  if (logins[0])
    var pass = (logins[0].username == 'user') ? true : false;

  if (pass) {
    // promptPassword
    var prompts = Components.classes['@mozilla.org/embedcomp/prompt-service;1'].getService(Components.interfaces.nsIPromptService);

    input = {value:''};
    check = {value:false};
    var locale = document.getElementById('OnlyMySites.locale');
    okorcancel = prompts.promptPassword(null, locale.getString('Caption_Authenticate'), locale.getString('Enter_your_password'), input, null, check);

    if (okorcancel)
      if (this.hex_md5(input.value) == logins[0].password)
        return true;
    else {
      this.Show_Warning(locale.getString('Access_denied'));
      return false;
    }
  } else
    return true;
},

hex_md5: function(str) {
  var converter = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
  // we use UTF-8 here, you can choose other encodings.
  converter.charset = 'UTF-8';
  // result is an out parameter,
  // result.value will contain the array length
  var result = {};
  // data is an array of bytes
  var data = converter.convertToByteArray(str, result);
  var ch = Components.classes['@mozilla.org/security/hash;1'].createInstance(Components.interfaces.nsICryptoHash);
  ch.init(ch.MD5);
  ch.update(data, data.length);
  var hash = ch.finish(false);

  // return the two-digit hexadecimal code for a byte
  function toHexString(charCode) {
    return ('0' + charCode.toString(16)).slice(-2);
  }

  // convert the binary hash data to a hex string.
  return [toHexString(hash.charCodeAt(i)) for (i in hash)].join('');
},









}; //OnlyMySites

window.addEventListener('load', function(e) { OnlyMySites.init(e); }, false);
window.addEventListener('unload', function(e) { OnlyMySites.unload(e); }, false);
