var OnlyMySites_settings = {

prefs : Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.OnlyMySites.'),


myLoginManager : Components.classes['@mozilla.org/login-manager;1'].getService(Components.interfaces.nsILoginManager),

cmd_Button_Save_Password: function() {
  if (document.getElementById('Type_New_Password').value == '')
    return;
  var nsLoginInfo = new Components.Constructor('@mozilla.org/login-manager/loginInfo;1',Components.interfaces.nsILoginInfo,'init');
  var extLoginInfo = new nsLoginInfo('chrome://OnlyMySites', null, 'Pref. Pass', 'user', this.hex_md5(document.getElementById('Type_New_Password').value), '', '');
  var logins = this.myLoginManager.findLogins({}, 'chrome://OnlyMySites', null, 'Pref. Pass');
  if (logins[0])
    if (logins[0].username == 'user')
      this.myLoginManager.removeLogin(logins[0]);
  this.myLoginManager.addLogin(extLoginInfo);

  document.getElementById('Type_New_Password').disabled =
  document.getElementById('Button_Set_Password').disabled =
  document.getElementById('Button_Set_Password').hidden = true;
  document.getElementById('Button_Clear_Password').disabled =
  document.getElementById('Button_Clear_Password').hidden = false;
},

cmd_Button_Remove_Password: function() {
  var logins = this.myLoginManager.findLogins({}, 'chrome://OnlyMySites', null, 'Pref. Pass');
  this.myLoginManager.removeLogin(logins[0]);
  document.getElementById('Type_New_Password').disabled =
  document.getElementById('Button_Set_Password').disabled =
  document.getElementById('Button_Set_Password').hidden = false;
  document.getElementById('Button_Clear_Password').disabled =
  document.getElementById('Button_Clear_Password').hidden = true;
},





onpaneok: function() {
    var str = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
    str.data = document.getElementById('Textbox_Sites').value;
    this.prefs.setComplexValue('Sites', Components.interfaces.nsISupportsString, str);
},


onpaneload: function() {
  var Sites = this.prefs.getComplexValue('Sites', Components.interfaces.nsISupportsString).data
  .replace(/\|/gm, "\,")
  .replace(/\\\./gm, ".")
  .replace(/\\\\\./g, '.');

  if (/\,$/.test(Sites))
    document.getElementById('Textbox_Sites').value = Sites.substring(0, Sites.length-1);
  else
    document.getElementById('Textbox_Sites').value = Sites;

  var logins = this.myLoginManager.findLogins({}, 'chrome://OnlyMySites', null, 'Pref. Pass');
  var pass = false;
  if (logins[0])
    pass = (logins[0].username == 'user') ? true : false;
  document.getElementById('Type_New_Password').disabled =
  document.getElementById('Button_Set_Password').disabled =
  document.getElementById('Button_Set_Password').hidden = pass ? true : false;
  document.getElementById('Button_Clear_Password').disabled =
  document.getElementById('Button_Clear_Password').hidden = pass ? false : true;
},



hex_md5: function(str) {
  var converter = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
  // we use UTF-8 here, you can choose other encodings.
  converter.charset = 'UTF-8';
  // result is an out parameter,
  // result.value will contain the array length
  var result = {};
  // data is an array of bytes
  var data = converter.convertToByteArray(str, result);
  var ch = Components.classes['@mozilla.org/security/hash;1'].createInstance(Components.interfaces.nsICryptoHash);
  ch.init(ch.MD5);
  ch.update(data, data.length);
  var hash = ch.finish(false);

  // return the two-digit hexadecimal code for a byte
  function toHexString(charCode) {
    return ('0' + charCode.toString(16)).slice(-2);
  }

  // convert the binary hash data to a hex string.
  return [toHexString(hash.charCodeAt(i)) for (i in hash)].join('');
},

openUrl: function(helpPage) {
  var tabToSelect;

  // Check if the help page already open
  var recentWindow = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow('navigator:browser');
  var tabBrowser = recentWindow.gBrowser;
  var i = tabBrowser.browsers.length; while (i--)
  if (tabBrowser.browsers[i].currentURI.spec.indexOf(helpPage) == 0) {
    tabToSelect = tabBrowser.tabs[i];
    break;
  }
  if (!tabToSelect)
    tabToSelect = tabBrowser.addTab('about:blank');
  tabToSelect.linkedBrowser.stop();
  tabBrowser.selectedTab = tabToSelect;
  tabBrowser.selectedBrowser.userTypedValue = helpPage;
  recentWindow.loadURI(helpPage, null, null, false);
  recentWindow.focusElement(recentWindow.content);
}
} // OnlyMySites_settings
